package botworld;

import java.awt.*;

import prolog.*;
import prolog.math.*;

/**
 * Boxes.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: Box.java,v 1.4 2000/08/10 12:51:03 peteg Exp $
 */
public class Box extends WorldObject {
    /**
     * Constructs a new Box with given corners.
     */
    public Box(int bid, int left, int top, int right, int bottom) {
	id = bid;
	bounds = new Rectangle(left, top, right - left, bottom - top);
    }

    public Compound getFact() {
	Term[] args = new Term[] {
	    IntNum.make(id),
	    IntNum.make(bounds.x),
	    IntNum.make(bounds.y),
	    IntNum.make(bounds.x + bounds.width),
	    IntNum.make(bounds.y + bounds.height),
	};

	return(new Compound("box", args));

    }

    public void draw(Graphics g) {
	g.setColor(Color.gray);
	g.draw3DRect(bounds.x, bounds.y, bounds.width, bounds.height, true);
    }
}
