package prolog.lib;

import botworld.*;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>goto/3</TT>: Move bot to a given (x, y) position.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: goto_3.java,v 1.5 2000/08/10 12:51:03 peteg Exp $
 */
public class goto_3 extends CompiledPredicate {
    public goto_3() {
    }

    /*
     * arg0 = bot number (ignore).
     * (arg1, arg2) = (x, y) to move to.
     */
    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
// 	System.err.println("goto(" + args[0]
// 			   + ", " + args[1]
// 			   + ", " + args[2] + ")");

	try {
	    float x = ((Numeric)args[1].getBinding()).floatValue(),
		y = ((Numeric)args[2].getBinding()).floatValue();

	    ((Bot)p.obj).move(x, y);

	    return true;
	} catch(ClassCastException e) {
	    throw new ArgumentException("goto/3: invalid arguments: ", args);
	}
    }
}
