package prolog;

import java.io.*;

/**
 * A node in a sequence of <TT>Clauses</TT>.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: ClauseList.java,v 1.8 2000/11/07 12:04:55 peteg Exp $
 */
public class ClauseList implements Serializable {
    public Clause clause;
    public ClauseList next;

    ClauseList(Clause clause) {
	this(clause, null);
    }

    ClauseList(Clause clause, ClauseList next) {
	this.clause = clause;
	this.next   = next;
    }

    public String toString() {
	StringBuffer out = new StringBuffer();

	out.append(clause.toString());

	if(next != null) {
	    out.append(next.toString());
	}

	return out.toString();
    }
}
