package prolog;

/**
 * Represents a dynamically modifiable predicate.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: DynamicPredicate.java,v 1.11 2000/08/06 13:43:31 peteg Exp $
 * @see prolog.lib.abolish_1
 * @see prolog.lib.asserta_1
 * @see prolog.lib.assertz_1
 * @see prolog.lib.dynamic_1
 * @see prolog.lib.retract_1
 */
public class DynamicPredicate extends InterpretedPredicate {
    public DynamicPredicate(int arity) {
	// We choose an easy-to-update index here.
 	super(arity > 0 ? new ClauseIndexTrad() : new ClauseIndex());
    }

    public ClauseList getClauses() {
	return index.getClauses();
    }

    public void clear() {
	index.clear();
    }

    public void remove(Clause c) throws ArgumentException {
	index.remove(c);
    }

    public String toString() {
	StringBuffer out = new StringBuffer();

	out.append(" (dynamic)");
	out.append(super.toString());

 	return out.toString();
    }
}
