package prolog;

/**
 * <TT>';'('->'/2)/2</TT>: Represents an if-then-else goal in the body of a
 * clause.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: IfThenElse.java,v 1.2 2000/08/17 13:01:22 peteg Exp $
 */
public class IfThenElse extends IfThen {
    Goal else_goal;

    IfThenElse(Goal if_goal, Goal then_goal, Goal else_goal) {
	super(if_goal, then_goal);
	this.else_goal = else_goal;
    }

    public boolean unify(Term[] insts, Prolog p) throws PrologException {
	throw new RuntimeException("IfThenElse.unify()");
    }

    public boolean redo(Term[] insts, Prolog p, ChoicePoint cp) throws PrologException {
	throw new RuntimeException("IfThenElse.unify()");
    }

    /**
     * Instantiate a list of Goals with the given substitutions. We
     * overwrite the old <TT>Compound</TT> objects in the list with their
     * instantiated counterparts.
     */
    void instantiate(Term[] insts) {
	else_goal.instantiate(insts);
	super.instantiate(insts);
    }

    public String toString() {
	StringBuffer out = new StringBuffer();

	out.append("(");
	out.append(if_goal.toString());
	out.append(" -> ");
	out.append(then_goal.toString());
	out.append(" ; ");
	out.append(else_goal.toString());
	out.append(")");
	out.append(super.toString());

	return out.toString();
    }
}
