package prolog;

import prolog.math.Numeric;

/* The JavaClass package. */
import de.fub.bytecode.classfile.*;
import de.fub.bytecode.generic.*;

/**
 * Represents the <TT>Numeric</TT> type.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: NumericType.java,v 1.13 2000/11/12 12:22:45 peteg Exp $
 */
public class NumericType extends TermType {
    final static String ClassName = "prolog.math.Numeric";
    final static ObjectType JavaType = new ObjectType("prolog/math/Numeric");

    public NumericType() {
    }

    ObjectType getJavaType(TermInfo ti) {
	return JavaType;
    }

    TermInfo instantiate(Term t, TermInfo[] typevars,
			 TypeDictionary types, boolean map) {
	System.err.println("NumericType.instantiate(): " + this + " against " + t);

	Numeric n = (Numeric)t;

	return (t.ti = new TermInfo(new NumericType(), typevars));

// 	throw new RuntimeException();
    }

    boolean unify(TermInfo ti,
		  TermInfo arg,
		  TypeTrail trail) {
	System.err.println("NumericType.unify(): " + this + " against " + arg.type);

	if(arg.type instanceof TypeVariable) {
	    return arg.type.unify(arg, ti, trail);
	}

	// FIXME
	return arg.type instanceof NumericType;
    }

    public boolean compile_unify(ClauseCodeGen ccg,
				 TermInfo arg0, TermInfo arg1) {
 	if(arg1.type instanceof TypeVariable) {
 	    // Reverse data flow.
 	    return arg1.type.compile_unify(ccg, arg1, arg0);
 	}

	if(!(arg1.type instanceof NumericType)) {
	    throw new RuntimeException("NumericType.compile_unify() -- types don't match!");
	}

	ccg.numeric_unify(arg0, arg1);

	return true;
    }

    public void create(ClauseCodeGen ccg, TermInfo arg0) {
	throw new RuntimeException("NumericType.create()");
    }

    public void toString(StringBuffer out) {
	out.append("Numeric");
    }
}
