package prolog.lib;

import prolog.*;

/**
 * <TT>assertz/1</TT>: Adds a clause to the end of a predicate.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: assertz_1.java,v 1.10 2000/07/25 13:28:58 peteg Exp $
 * @see prolog.lib.abolish_1
 * @see prolog.lib.asserta_1
 * @see prolog.lib.retract_1
 */
public class assertz_1 extends CompiledPredicate {
    public assertz_1() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	Compound arg0;

	try {
	    arg0 = (Compound)args[0].getBinding();
	} catch (ClassCastException e) {
	    throw new ArgumentException("assertz/1: invalid argument: ", args);
	}

	Clause c = new Clause(arg0, p);
	Compound head = c.head;

	String f = head.functor;
	int a    = head.arity;

	try {
	    ((DynamicPredicate)p.db.get(f, a)).putz(c);
	} catch (ClassCastException e) {
	    throw new ArgumentException("assertz/1: predicate is not dynamic: ", f, a);
	}

	return true;
    }
}
