package prolog.lib;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>atomic/1</TT>: Is this <TT>Term</TT> an atom? (atom == Num, Compound
 * with arity = 0).
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: atomic_1.java,v 1.4 2000/08/10 12:51:03 peteg Exp $
 */
public class atomic_1 extends CompiledPredicate {
    public atomic_1() {
    }

    public boolean exec(Term[] args, Prolog p) {
	Term arg0 = args[0].getBinding();

	return arg0 instanceof Numeric ||
	    (arg0 instanceof Compound && ((Compound)arg0).arity == 0);
    }
}
