package prolog.lib;

import java.io.*;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>compile/1</TT>: Put in a <TT>JITPredicate</TT> record for the
 * specified predicate.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: compile_1.java,v 1.5 2000/11/03 00:58:29 peteg Exp $
 * @see prolog.PredicateCodeGen
 */
public class compile_1 extends CompiledPredicate {
    public compile_1() {
    }

    public boolean exec(Term[] args, Prolog p) throws PrologException {
	try{
	    Compound arg0 = (Compound)args[0];
 	    String f = ((Compound)arg0.args[0]).functor;
 	    int a = ((Numeric)arg0.args[1]).intValue();
	    Database db = p.db;

	    if(db.get(f, a) != null) {
                throw new PrologException("compile/1: predicate is already defined: " + arg0);
            }

            db.put(f, a, new JITPredicate(a));

	    return true;
	} catch (ClassCastException e) {
	    throw new ArgumentException("compile/1: invalid argument: ", args);
	}
    }
}
