package prolog.lib;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>ge/2</TT>: Greater than / equal to.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: ge_2.java,v 1.7 2000/08/10 12:51:03 peteg Exp $
 */
public class ge_2 extends CompiledPredicate {
    public ge_2() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	try {
	    Term arg0 = args[0].getBinding(), arg1 = args[1].getBinding();
	    Numeric r0, r1;

	    if(arg0 instanceof Compound) {
		r0 = is_2.eval((Compound)arg0);
	    } else {
		r0 = (Numeric)arg0;
	    }

	    if(arg1 instanceof Compound) {
		r1 = is_2.eval((Compound)arg1);
	    } else {
		r1 = (Numeric)arg1;
	    }

	    return r0.compare(r1) >= 0;

//   	    System.err.println("ge: " + arg0.val.toString() + " >= " + arg1.val.toString());
	} catch(ClassCastException e) {
	    throw new ArgumentException("ge/2: (>=) invalid arguments: ", args);
	}
    }
}
