package prolog.lib;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>tab/1</TT>: Print n tabs.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: tab_1.java,v 1.4 2000/08/10 12:51:04 peteg Exp $
 */
public class tab_1 extends CompiledPredicate {
    public tab_1() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	try {
	    int i = ((Numeric)args[0].getBinding()).intValue();

	    while(i-- > 0) {
		System.out.print("\t");
	    }

	    return true;
	} catch (ClassCastException e) {
	    throw new ArgumentException("tab/1: invalid argument: ", args);
	}
    }
}
