package prolog.util;

/**
 * Usual FIFO queue, no magic (not thread safe).
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: FIFOQueue.java,v 1.3 2000/08/06 13:43:44 peteg Exp $
 */
public class FIFOQueue implements Queue {
    private Element head, tail;

    public FIFOQueue() {
	head = tail = null;
    }

    public void enqueue(Object o) {
// 	System.err.println("FIFOQueue().enqueue: " + o);

	Element qe = new Element(o);

	if(head == null) {
	    head = tail = qe;
	} else {
	    head.next = qe;
	    head = qe;
	}
    }

    /**
     * Dequeue the next object, if there is one, null if not.
     */
    public Object dequeue() {
	if(tail == null) {
//  	    System.err.println("FIFOQueue.dequeue(): queue is empty.");
	    return null;
	} else {
	    Object o = tail.element;
	    tail = tail.next;

	    if(tail == null) {
		head = null;
	    }

	    return o;
	}
    }

    public boolean isEmpty() {
// 	System.err.println("FIFOQueue.isEmpty(): " + (tail == null));
	return tail == null;
    }

    public String toString() {
	StringBuffer out = new StringBuffer();

	for(Element qe = tail; qe != null; qe = qe.next) {
	    out.append(qe.toString());
	}

	return out.toString();
    }
}
