package prolog.util;

/**
 * LIFO Stack implementation <b>(not thread safe)</b>.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: Stack.java,v 1.3 2000/08/06 13:43:44 peteg Exp $
 */
public class Stack {
    private Element stack;

    public Stack() {
    }

    public void push(Object o) {
	stack = new Element(o, stack);
    }

    public Object pop() {
	if(stack == null)
	    return null;
	else {
	    Object o = stack.element;

	    stack = stack.next;
	    return o;
	}
    }

    public Object peek() {
	return (stack == null) ? null : stack.element;
    }

    public boolean empty() {
	return stack == null;
    }
}
