package prolog.lib;

import prolog.*;
import prolog.math.*;

/* range/3: generate a list of numbers. range(int, int, binding). */
public class range_3 extends CompiledPredicate {
    private static FunctorArity list_cell = Compound.map_functor_arity(".", 2);
    private static Compound end_of_list = new Compound("[]");

    public range_3() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	int      arg0 = ((IntNum)args[0].getBinding()).ival;
	int      arg1 = ((IntNum)args[1].getBinding()).ival;
	Binding  arg2 = (Binding)args[2].getBinding();

	Compound new_list_start = end_of_list;

	while(arg0 <= arg1) {
	    Term[] cell_args = new Term[2];
	    Compound cell = new Compound(list_cell, cell_args);

	    cell_args[0] = IntNum.make(arg1);
	    cell.args[1] = new_list_start;
	    new_list_start = cell;

	    arg1--;
	}

	p.push(arg2, new_list_start);

	return true;
    }
}
